/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Http;
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Core.Utils;
using Aliyun.Acs.Dts.Transform;
using Aliyun.Acs.Dts.Transform.V20160801;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
    public class ConfigureSubscriptionInstanceRequest : RpcAcsRequest<ConfigureSubscriptionInstanceResponse>
    {
        public ConfigureSubscriptionInstanceRequest()
            : base("Dts", "2016-08-01", "ConfigureSubscriptionInstance")
        {
			Method = MethodType.POST;
        }

		private string subscriptionInstanceId;

		private bool? subscriptionDataTypeDML;

		private bool? subscriptionDataTypeDDL;

		private string subscriptionObject;

		private string sourceEndpointInstanceID;

		private string sourceEndpointInstanceType;

		private string subscriptionInstanceName;

		public string SubscriptionInstanceId
		{
			get
			{
				return subscriptionInstanceId;
			}
			set	
			{
				subscriptionInstanceId = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionInstanceId", value);
			}
		}

		public bool? SubscriptionDataTypeDML
		{
			get
			{
				return subscriptionDataTypeDML;
			}
			set	
			{
				subscriptionDataTypeDML = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionDataType.DML", value.ToString());
			}
		}

		public bool? SubscriptionDataTypeDDL
		{
			get
			{
				return subscriptionDataTypeDDL;
			}
			set	
			{
				subscriptionDataTypeDDL = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionDataType.DDL", value.ToString());
			}
		}

		public string SubscriptionObject
		{
			get
			{
				return subscriptionObject;
			}
			set	
			{
				subscriptionObject = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionObject", value);
			}
		}

		public string SourceEndpointInstanceID
		{
			get
			{
				return sourceEndpointInstanceID;
			}
			set	
			{
				sourceEndpointInstanceID = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.InstanceID", value);
			}
		}

		public string SourceEndpointInstanceType
		{
			get
			{
				return sourceEndpointInstanceType;
			}
			set	
			{
				sourceEndpointInstanceType = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.InstanceType", value);
			}
		}

		public string SubscriptionInstanceName
		{
			get
			{
				return subscriptionInstanceName;
			}
			set	
			{
				subscriptionInstanceName = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionInstanceName", value);
			}
		}

        public override ConfigureSubscriptionInstanceResponse GetResponse(Core.Transform.UnmarshallerContext unmarshallerContext)
        {
            return ConfigureSubscriptionInstanceResponseUnmarshaller.Unmarshall(unmarshallerContext);
        }
    }
}