/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Http;
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Core.Utils;
using Aliyun.Acs.Dts.Transform;
using Aliyun.Acs.Dts.Transform.V20160801;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
    public class ConfigureSynchronizationJobRequest : RpcAcsRequest<ConfigureSynchronizationJobResponse>
    {
        public ConfigureSynchronizationJobRequest()
            : base("Dts", "2016-08-01", "ConfigureSynchronizationJob")
        {
        }

		private bool? partitionKeyModifyTime_Month;

		private bool? dataInitialization;

		private string destinationEndpointInstanceId;

		private bool? partitionKeyModifyTime_Minute;

		private bool? structureInitialization;

		private string sourceEndpointOwnerID;

		private string sourceEndpointRole;

		private bool? partitionKeyModifyTime_Day;

		private string synchronizationJobId;

		private bool? partitionKeyModifyTime_Year;

		private string synchronizationObjects;

		private string synchronizationJobName;

		private bool? partitionKeyModifyTime_Hour;

		private string sourceEndpointInstanceId;

		public bool? PartitionKeyModifyTime_Month
		{
			get
			{
				return partitionKeyModifyTime_Month;
			}
			set	
			{
				partitionKeyModifyTime_Month = value;
				DictionaryUtil.Add(QueryParameters, "PartitionKey.ModifyTime_Month", value.ToString());
			}
		}

		public bool? DataInitialization
		{
			get
			{
				return dataInitialization;
			}
			set	
			{
				dataInitialization = value;
				DictionaryUtil.Add(QueryParameters, "DataInitialization", value.ToString());
			}
		}

		public string DestinationEndpointInstanceId
		{
			get
			{
				return destinationEndpointInstanceId;
			}
			set	
			{
				destinationEndpointInstanceId = value;
				DictionaryUtil.Add(QueryParameters, "DestinationEndpoint.InstanceId", value);
			}
		}

		public bool? PartitionKeyModifyTime_Minute
		{
			get
			{
				return partitionKeyModifyTime_Minute;
			}
			set	
			{
				partitionKeyModifyTime_Minute = value;
				DictionaryUtil.Add(QueryParameters, "PartitionKey.ModifyTime_Minute", value.ToString());
			}
		}

		public bool? StructureInitialization
		{
			get
			{
				return structureInitialization;
			}
			set	
			{
				structureInitialization = value;
				DictionaryUtil.Add(QueryParameters, "StructureInitialization", value.ToString());
			}
		}

		public string SourceEndpointOwnerID
		{
			get
			{
				return sourceEndpointOwnerID;
			}
			set	
			{
				sourceEndpointOwnerID = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.OwnerID", value);
			}
		}

		public string SourceEndpointRole
		{
			get
			{
				return sourceEndpointRole;
			}
			set	
			{
				sourceEndpointRole = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.Role", value);
			}
		}

		public bool? PartitionKeyModifyTime_Day
		{
			get
			{
				return partitionKeyModifyTime_Day;
			}
			set	
			{
				partitionKeyModifyTime_Day = value;
				DictionaryUtil.Add(QueryParameters, "PartitionKey.ModifyTime_Day", value.ToString());
			}
		}

		public string SynchronizationJobId
		{
			get
			{
				return synchronizationJobId;
			}
			set	
			{
				synchronizationJobId = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationJobId", value);
			}
		}

		public bool? PartitionKeyModifyTime_Year
		{
			get
			{
				return partitionKeyModifyTime_Year;
			}
			set	
			{
				partitionKeyModifyTime_Year = value;
				DictionaryUtil.Add(QueryParameters, "PartitionKey.ModifyTime_Year", value.ToString());
			}
		}

		public string SynchronizationObjects
		{
			get
			{
				return synchronizationObjects;
			}
			set	
			{
				synchronizationObjects = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationObjects", value);
			}
		}

		public string SynchronizationJobName
		{
			get
			{
				return synchronizationJobName;
			}
			set	
			{
				synchronizationJobName = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationJobName", value);
			}
		}

		public bool? PartitionKeyModifyTime_Hour
		{
			get
			{
				return partitionKeyModifyTime_Hour;
			}
			set	
			{
				partitionKeyModifyTime_Hour = value;
				DictionaryUtil.Add(QueryParameters, "PartitionKey.ModifyTime_Hour", value.ToString());
			}
		}

		public string SourceEndpointInstanceId
		{
			get
			{
				return sourceEndpointInstanceId;
			}
			set	
			{
				sourceEndpointInstanceId = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.InstanceId", value);
			}
		}

        public override ConfigureSynchronizationJobResponse GetResponse(Core.Transform.UnmarshallerContext unmarshallerContext)
        {
            return ConfigureSynchronizationJobResponseUnmarshaller.Unmarshall(unmarshallerContext);
        }
    }
}