/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
	public class DescirbeMigrationJobsResponse : AcsResponse
	{

		private int? pageNumber;

		private long? totalRecordCount;

		private int? pageRecordCount;

		private List<DescirbeMigrationJobs_MigrationJob> migrationJobs;

		public int? PageNumber
		{
			get
			{
				return pageNumber;
			}
			set	
			{
				pageNumber = value;
			}
		}

		public long? TotalRecordCount
		{
			get
			{
				return totalRecordCount;
			}
			set	
			{
				totalRecordCount = value;
			}
		}

		public int? PageRecordCount
		{
			get
			{
				return pageRecordCount;
			}
			set	
			{
				pageRecordCount = value;
			}
		}

		public List<DescirbeMigrationJobs_MigrationJob> MigrationJobs
		{
			get
			{
				return migrationJobs;
			}
			set	
			{
				migrationJobs = value;
			}
		}

		public class DescirbeMigrationJobs_MigrationJob
		{

			private string migrationJobID;

			private string migrationJobName;

			private string payType;

			private string migrationJobClass;

			private string migrationJobStatus;

			private List<DescirbeMigrationJobs_SynchronousObject> migrationObject;

			private DescirbeMigrationJobs_SourceEndpoint sourceEndpoint;

			private DescirbeMigrationJobs_DestinationEndpoint destinationEndpoint;

			private DescirbeMigrationJobs_MigrationMode migrationMode;

			private DescirbeMigrationJobs_Precheck precheck;

			private DescirbeMigrationJobs_StructureInitialization structureInitialization;

			private DescirbeMigrationJobs_DataInitialization dataInitialization;

			private DescirbeMigrationJobs_DataSynchronization dataSynchronization;

			public string MigrationJobID
			{
				get
				{
					return migrationJobID;
				}
				set	
				{
					migrationJobID = value;
				}
			}

			public string MigrationJobName
			{
				get
				{
					return migrationJobName;
				}
				set	
				{
					migrationJobName = value;
				}
			}

			public string PayType
			{
				get
				{
					return payType;
				}
				set	
				{
					payType = value;
				}
			}

			public string MigrationJobClass
			{
				get
				{
					return migrationJobClass;
				}
				set	
				{
					migrationJobClass = value;
				}
			}

			public string MigrationJobStatus
			{
				get
				{
					return migrationJobStatus;
				}
				set	
				{
					migrationJobStatus = value;
				}
			}

			public List<DescirbeMigrationJobs_SynchronousObject> MigrationObject
			{
				get
				{
					return migrationObject;
				}
				set	
				{
					migrationObject = value;
				}
			}

			public DescirbeMigrationJobs_SourceEndpoint SourceEndpoint
			{
				get
				{
					return sourceEndpoint;
				}
				set	
				{
					sourceEndpoint = value;
				}
			}

			public DescirbeMigrationJobs_DestinationEndpoint DestinationEndpoint
			{
				get
				{
					return destinationEndpoint;
				}
				set	
				{
					destinationEndpoint = value;
				}
			}

			public DescirbeMigrationJobs_MigrationMode MigrationMode
			{
				get
				{
					return migrationMode;
				}
				set	
				{
					migrationMode = value;
				}
			}

			public DescirbeMigrationJobs_Precheck Precheck
			{
				get
				{
					return precheck;
				}
				set	
				{
					precheck = value;
				}
			}

			public DescirbeMigrationJobs_StructureInitialization StructureInitialization
			{
				get
				{
					return structureInitialization;
				}
				set	
				{
					structureInitialization = value;
				}
			}

			public DescirbeMigrationJobs_DataInitialization DataInitialization
			{
				get
				{
					return dataInitialization;
				}
				set	
				{
					dataInitialization = value;
				}
			}

			public DescirbeMigrationJobs_DataSynchronization DataSynchronization
			{
				get
				{
					return dataSynchronization;
				}
				set	
				{
					dataSynchronization = value;
				}
			}

			public class DescirbeMigrationJobs_SynchronousObject
			{

				private string databaseName;

				private string wholeDatabase;

				private List<string> tableList;

				public string DatabaseName
				{
					get
					{
						return databaseName;
					}
					set	
					{
						databaseName = value;
					}
				}

				public string WholeDatabase
				{
					get
					{
						return wholeDatabase;
					}
					set	
					{
						wholeDatabase = value;
					}
				}

				public List<string> TableList
				{
					get
					{
						return tableList;
					}
					set	
					{
						tableList = value;
					}
				}
			}

			public class DescirbeMigrationJobs_SourceEndpoint
			{

				private string instanceID;

				private string instanceType;

				private string engineName;

				private string iP;

				private string port;

				private string databaseName;

				private string oracleSID;

				private string userName;

				public string InstanceID
				{
					get
					{
						return instanceID;
					}
					set	
					{
						instanceID = value;
					}
				}

				public string InstanceType
				{
					get
					{
						return instanceType;
					}
					set	
					{
						instanceType = value;
					}
				}

				public string EngineName
				{
					get
					{
						return engineName;
					}
					set	
					{
						engineName = value;
					}
				}

				public string IP
				{
					get
					{
						return iP;
					}
					set	
					{
						iP = value;
					}
				}

				public string Port
				{
					get
					{
						return port;
					}
					set	
					{
						port = value;
					}
				}

				public string DatabaseName
				{
					get
					{
						return databaseName;
					}
					set	
					{
						databaseName = value;
					}
				}

				public string OracleSID
				{
					get
					{
						return oracleSID;
					}
					set	
					{
						oracleSID = value;
					}
				}

				public string UserName
				{
					get
					{
						return userName;
					}
					set	
					{
						userName = value;
					}
				}
			}

			public class DescirbeMigrationJobs_DestinationEndpoint
			{

				private string instanceID;

				private string instanceType;

				private string engineName;

				private string iP;

				private string port;

				private string databaseName;

				private string oracleSID;

				private string userName;

				public string InstanceID
				{
					get
					{
						return instanceID;
					}
					set	
					{
						instanceID = value;
					}
				}

				public string InstanceType
				{
					get
					{
						return instanceType;
					}
					set	
					{
						instanceType = value;
					}
				}

				public string EngineName
				{
					get
					{
						return engineName;
					}
					set	
					{
						engineName = value;
					}
				}

				public string IP
				{
					get
					{
						return iP;
					}
					set	
					{
						iP = value;
					}
				}

				public string Port
				{
					get
					{
						return port;
					}
					set	
					{
						port = value;
					}
				}

				public string DatabaseName
				{
					get
					{
						return databaseName;
					}
					set	
					{
						databaseName = value;
					}
				}

				public string OracleSID
				{
					get
					{
						return oracleSID;
					}
					set	
					{
						oracleSID = value;
					}
				}

				public string UserName
				{
					get
					{
						return userName;
					}
					set	
					{
						userName = value;
					}
				}
			}

			public class DescirbeMigrationJobs_MigrationMode
			{

				private bool? structureInitialization;

				private bool? dataInitialization;

				private bool? dataSynchronization;

				public bool? StructureInitialization
				{
					get
					{
						return structureInitialization;
					}
					set	
					{
						structureInitialization = value;
					}
				}

				public bool? DataInitialization
				{
					get
					{
						return dataInitialization;
					}
					set	
					{
						dataInitialization = value;
					}
				}

				public bool? DataSynchronization
				{
					get
					{
						return dataSynchronization;
					}
					set	
					{
						dataSynchronization = value;
					}
				}
			}

			public class DescirbeMigrationJobs_Precheck
			{

				private string status;

				private string percent;

				public string Status
				{
					get
					{
						return status;
					}
					set	
					{
						status = value;
					}
				}

				public string Percent
				{
					get
					{
						return percent;
					}
					set	
					{
						percent = value;
					}
				}
			}

			public class DescirbeMigrationJobs_StructureInitialization
			{

				private string status;

				private string percent;

				private string errorMessage;

				private string progress;

				public string Status
				{
					get
					{
						return status;
					}
					set	
					{
						status = value;
					}
				}

				public string Percent
				{
					get
					{
						return percent;
					}
					set	
					{
						percent = value;
					}
				}

				public string ErrorMessage
				{
					get
					{
						return errorMessage;
					}
					set	
					{
						errorMessage = value;
					}
				}

				public string Progress
				{
					get
					{
						return progress;
					}
					set	
					{
						progress = value;
					}
				}
			}

			public class DescirbeMigrationJobs_DataInitialization
			{

				private string status;

				private string percent;

				private string errorMessage;

				private string progress;

				public string Status
				{
					get
					{
						return status;
					}
					set	
					{
						status = value;
					}
				}

				public string Percent
				{
					get
					{
						return percent;
					}
					set	
					{
						percent = value;
					}
				}

				public string ErrorMessage
				{
					get
					{
						return errorMessage;
					}
					set	
					{
						errorMessage = value;
					}
				}

				public string Progress
				{
					get
					{
						return progress;
					}
					set	
					{
						progress = value;
					}
				}
			}

			public class DescirbeMigrationJobs_DataSynchronization
			{

				private string status;

				private string percent;

				private string errorMessage;

				private string delay;

				public string Status
				{
					get
					{
						return status;
					}
					set	
					{
						status = value;
					}
				}

				public string Percent
				{
					get
					{
						return percent;
					}
					set	
					{
						percent = value;
					}
				}

				public string ErrorMessage
				{
					get
					{
						return errorMessage;
					}
					set	
					{
						errorMessage = value;
					}
				}

				public string Delay
				{
					get
					{
						return delay;
					}
					set	
					{
						delay = value;
					}
				}
			}
		}
	}
}