/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
	public class DescribeMigrationJobStatusResponse : AcsResponse
	{

		private string migrationJobId;

		private string migrationJobName;

		private string payType;

		private string migrationJobClass;

		private string migrationObject;

		private string migrationJobStatus;

		private DescribeMigrationJobStatus_SourceEndpoint sourceEndpoint;

		private DescribeMigrationJobStatus_DestinationEndpoint destinationEndpoint;

		private DescribeMigrationJobStatus_MigrationMode migrationMode;

		private DescribeMigrationJobStatus_PrecheckStatus precheckStatus;

		private DescribeMigrationJobStatus_StructureInitializationStatus structureInitializationStatus;

		private DescribeMigrationJobStatus_DataInitializationStatus dataInitializationStatus;

		private DescribeMigrationJobStatus_DataSynchronizationStatus dataSynchronizationStatus;

		public string MigrationJobId
		{
			get
			{
				return migrationJobId;
			}
			set	
			{
				migrationJobId = value;
			}
		}

		public string MigrationJobName
		{
			get
			{
				return migrationJobName;
			}
			set	
			{
				migrationJobName = value;
			}
		}

		public string PayType
		{
			get
			{
				return payType;
			}
			set	
			{
				payType = value;
			}
		}

		public string MigrationJobClass
		{
			get
			{
				return migrationJobClass;
			}
			set	
			{
				migrationJobClass = value;
			}
		}

		public string MigrationObject
		{
			get
			{
				return migrationObject;
			}
			set	
			{
				migrationObject = value;
			}
		}

		public string MigrationJobStatus
		{
			get
			{
				return migrationJobStatus;
			}
			set	
			{
				migrationJobStatus = value;
			}
		}

		public DescribeMigrationJobStatus_SourceEndpoint SourceEndpoint
		{
			get
			{
				return sourceEndpoint;
			}
			set	
			{
				sourceEndpoint = value;
			}
		}

		public DescribeMigrationJobStatus_DestinationEndpoint DestinationEndpoint
		{
			get
			{
				return destinationEndpoint;
			}
			set	
			{
				destinationEndpoint = value;
			}
		}

		public DescribeMigrationJobStatus_MigrationMode MigrationMode
		{
			get
			{
				return migrationMode;
			}
			set	
			{
				migrationMode = value;
			}
		}

		public DescribeMigrationJobStatus_PrecheckStatus PrecheckStatus
		{
			get
			{
				return precheckStatus;
			}
			set	
			{
				precheckStatus = value;
			}
		}

		public DescribeMigrationJobStatus_StructureInitializationStatus StructureInitializationStatus
		{
			get
			{
				return structureInitializationStatus;
			}
			set	
			{
				structureInitializationStatus = value;
			}
		}

		public DescribeMigrationJobStatus_DataInitializationStatus DataInitializationStatus
		{
			get
			{
				return dataInitializationStatus;
			}
			set	
			{
				dataInitializationStatus = value;
			}
		}

		public DescribeMigrationJobStatus_DataSynchronizationStatus DataSynchronizationStatus
		{
			get
			{
				return dataSynchronizationStatus;
			}
			set	
			{
				dataSynchronizationStatus = value;
			}
		}

		public class DescribeMigrationJobStatus_SourceEndpoint
		{

			private string instanceType;

			private string instanceId;

			private string engineName;

			private string iP;

			private string port;

			private string databaseName;

			private string oracleSID;

			private string userName;

			public string InstanceType
			{
				get
				{
					return instanceType;
				}
				set	
				{
					instanceType = value;
				}
			}

			public string InstanceId
			{
				get
				{
					return instanceId;
				}
				set	
				{
					instanceId = value;
				}
			}

			public string EngineName
			{
				get
				{
					return engineName;
				}
				set	
				{
					engineName = value;
				}
			}

			public string IP
			{
				get
				{
					return iP;
				}
				set	
				{
					iP = value;
				}
			}

			public string Port
			{
				get
				{
					return port;
				}
				set	
				{
					port = value;
				}
			}

			public string DatabaseName
			{
				get
				{
					return databaseName;
				}
				set	
				{
					databaseName = value;
				}
			}

			public string OracleSID
			{
				get
				{
					return oracleSID;
				}
				set	
				{
					oracleSID = value;
				}
			}

			public string UserName
			{
				get
				{
					return userName;
				}
				set	
				{
					userName = value;
				}
			}
		}

		public class DescribeMigrationJobStatus_DestinationEndpoint
		{

			private string instanceType;

			private string instanceId;

			private string engineName;

			private string iP;

			private string port;

			private string databaseName;

			private string oracleSID;

			private string userName;

			public string InstanceType
			{
				get
				{
					return instanceType;
				}
				set	
				{
					instanceType = value;
				}
			}

			public string InstanceId
			{
				get
				{
					return instanceId;
				}
				set	
				{
					instanceId = value;
				}
			}

			public string EngineName
			{
				get
				{
					return engineName;
				}
				set	
				{
					engineName = value;
				}
			}

			public string IP
			{
				get
				{
					return iP;
				}
				set	
				{
					iP = value;
				}
			}

			public string Port
			{
				get
				{
					return port;
				}
				set	
				{
					port = value;
				}
			}

			public string DatabaseName
			{
				get
				{
					return databaseName;
				}
				set	
				{
					databaseName = value;
				}
			}

			public string OracleSID
			{
				get
				{
					return oracleSID;
				}
				set	
				{
					oracleSID = value;
				}
			}

			public string UserName
			{
				get
				{
					return userName;
				}
				set	
				{
					userName = value;
				}
			}
		}

		public class DescribeMigrationJobStatus_MigrationMode
		{

			private bool? structureInitialization;

			private bool? dataInitialization;

			private bool? dataSynchronization;

			public bool? StructureInitialization
			{
				get
				{
					return structureInitialization;
				}
				set	
				{
					structureInitialization = value;
				}
			}

			public bool? DataInitialization
			{
				get
				{
					return dataInitialization;
				}
				set	
				{
					dataInitialization = value;
				}
			}

			public bool? DataSynchronization
			{
				get
				{
					return dataSynchronization;
				}
				set	
				{
					dataSynchronization = value;
				}
			}
		}

		public class DescribeMigrationJobStatus_PrecheckStatus
		{

			private string status;

			private string percent;

			private List<DescribeMigrationJobStatus_CheckItem> detail;

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string Percent
			{
				get
				{
					return percent;
				}
				set	
				{
					percent = value;
				}
			}

			public List<DescribeMigrationJobStatus_CheckItem> Detail
			{
				get
				{
					return detail;
				}
				set	
				{
					detail = value;
				}
			}

			public class DescribeMigrationJobStatus_CheckItem
			{

				private string itemName;

				private string checkStatus;

				private string errorMessage;

				private string repairMethod;

				public string ItemName
				{
					get
					{
						return itemName;
					}
					set	
					{
						itemName = value;
					}
				}

				public string CheckStatus
				{
					get
					{
						return checkStatus;
					}
					set	
					{
						checkStatus = value;
					}
				}

				public string ErrorMessage
				{
					get
					{
						return errorMessage;
					}
					set	
					{
						errorMessage = value;
					}
				}

				public string RepairMethod
				{
					get
					{
						return repairMethod;
					}
					set	
					{
						repairMethod = value;
					}
				}
			}
		}

		public class DescribeMigrationJobStatus_StructureInitializationStatus
		{

			private string status;

			private string percent;

			private string errorMessage;

			private string progress;

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string Percent
			{
				get
				{
					return percent;
				}
				set	
				{
					percent = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}

			public string Progress
			{
				get
				{
					return progress;
				}
				set	
				{
					progress = value;
				}
			}
		}

		public class DescribeMigrationJobStatus_DataInitializationStatus
		{

			private string status;

			private string percent;

			private string errorMessage;

			private string progress;

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string Percent
			{
				get
				{
					return percent;
				}
				set	
				{
					percent = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}

			public string Progress
			{
				get
				{
					return progress;
				}
				set	
				{
					progress = value;
				}
			}
		}

		public class DescribeMigrationJobStatus_DataSynchronizationStatus
		{

			private string status;

			private string percent;

			private string errorMessage;

			private string delay;

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string Percent
			{
				get
				{
					return percent;
				}
				set	
				{
					percent = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}

			public string Delay
			{
				get
				{
					return delay;
				}
				set	
				{
					delay = value;
				}
			}
		}
	}
}