/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Http;
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Core.Utils;
using Aliyun.Acs.Dts.Transform;
using Aliyun.Acs.Dts.Transform.V20160801;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
    public class DescribeSubscriptionInstancesRequest : RpcAcsRequest<DescribeSubscriptionInstancesResponse>
    {
        public DescribeSubscriptionInstancesRequest()
            : base("Dts", "2016-08-01", "DescribeSubscriptionInstances")
        {
        }

		private int? pageSize;

		private string clientToken;

		private int? pageNum;

		private string subscriptionInstanceName;

		public int? PageSize
		{
			get
			{
				return pageSize;
			}
			set	
			{
				pageSize = value;
				DictionaryUtil.Add(QueryParameters, "PageSize", value.ToString());
			}
		}

		public string ClientToken
		{
			get
			{
				return clientToken;
			}
			set	
			{
				clientToken = value;
				DictionaryUtil.Add(QueryParameters, "ClientToken", value);
			}
		}

		public int? PageNum
		{
			get
			{
				return pageNum;
			}
			set	
			{
				pageNum = value;
				DictionaryUtil.Add(QueryParameters, "PageNum", value.ToString());
			}
		}

		public string SubscriptionInstanceName
		{
			get
			{
				return subscriptionInstanceName;
			}
			set	
			{
				subscriptionInstanceName = value;
				DictionaryUtil.Add(QueryParameters, "SubscriptionInstanceName", value);
			}
		}

        public override DescribeSubscriptionInstancesResponse GetResponse(Core.Transform.UnmarshallerContext unmarshallerContext)
        {
            return DescribeSubscriptionInstancesResponseUnmarshaller.Unmarshall(unmarshallerContext);
        }
    }
}