/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescirbeMigrationJobsResponseUnmarshaller
    {
        public static DescirbeMigrationJobsResponse Unmarshall(UnmarshallerContext context)
        {
			DescirbeMigrationJobsResponse descirbeMigrationJobsResponse = new DescirbeMigrationJobsResponse();

			descirbeMigrationJobsResponse.HttpResponse = context.HttpResponse;
			descirbeMigrationJobsResponse.PageNumber = context.IntegerValue("DescirbeMigrationJobs.PageNumber");
			descirbeMigrationJobsResponse.TotalRecordCount = context.LongValue("DescirbeMigrationJobs.TotalRecordCount");
			descirbeMigrationJobsResponse.PageRecordCount = context.IntegerValue("DescirbeMigrationJobs.PageRecordCount");

			List<DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob> descirbeMigrationJobsResponse_migrationJobs = new List<DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob>();
			for (int i = 0; i < context.Length("DescirbeMigrationJobs.MigrationJobs.Length"); i++) {
				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob migrationJob = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob();
				migrationJob.MigrationJobID = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationJobID");
				migrationJob.MigrationJobName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationJobName");
				migrationJob.PayType = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].PayType");
				migrationJob.MigrationJobClass = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationJobClass");
				migrationJob.MigrationJobStatus = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationJobStatus");

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SourceEndpoint sourceEndpoint = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SourceEndpoint();
				sourceEndpoint.InstanceID = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.InstanceID");
				sourceEndpoint.InstanceType = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.InstanceType");
				sourceEndpoint.EngineName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.EngineName");
				sourceEndpoint.IP = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.IP");
				sourceEndpoint.Port = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.Port");
				sourceEndpoint.DatabaseName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.DatabaseName");
				sourceEndpoint.OracleSID = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.OracleSID");
				sourceEndpoint.UserName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].SourceEndpoint.UserName");
				migrationJob.SourceEndpoint = sourceEndpoint;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DestinationEndpoint destinationEndpoint = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DestinationEndpoint();
				destinationEndpoint.InstanceID = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.InstanceID");
				destinationEndpoint.InstanceType = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.InstanceType");
				destinationEndpoint.EngineName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.EngineName");
				destinationEndpoint.IP = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.IP");
				destinationEndpoint.Port = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.Port");
				destinationEndpoint.DatabaseName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.DatabaseName");
				destinationEndpoint.OracleSID = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.OracleSID");
				destinationEndpoint.UserName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DestinationEndpoint.UserName");
				migrationJob.DestinationEndpoint = destinationEndpoint;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_MigrationMode migrationMode = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_MigrationMode();
				migrationMode.StructureInitialization = context.BooleanValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationMode.StructureInitialization");
				migrationMode.DataInitialization = context.BooleanValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationMode.DataInitialization");
				migrationMode.DataSynchronization = context.BooleanValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationMode.DataSynchronization");
				migrationJob.MigrationMode = migrationMode;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_Precheck precheck = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_Precheck();
				precheck.Status = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].Precheck.Status");
				precheck.Percent = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].Precheck.Percent");
				migrationJob.Precheck = precheck;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_StructureInitialization structureInitialization = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_StructureInitialization();
				structureInitialization.Status = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].StructureInitialization.Status");
				structureInitialization.Percent = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].StructureInitialization.Percent");
				structureInitialization.ErrorMessage = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].StructureInitialization.ErrorMessage");
				structureInitialization.Progress = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].StructureInitialization.Progress");
				migrationJob.StructureInitialization = structureInitialization;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DataInitialization dataInitialization = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DataInitialization();
				dataInitialization.Status = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataInitialization.Status");
				dataInitialization.Percent = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataInitialization.Percent");
				dataInitialization.ErrorMessage = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataInitialization.ErrorMessage");
				dataInitialization.Progress = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataInitialization.Progress");
				migrationJob.DataInitialization = dataInitialization;

				DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DataSynchronization dataSynchronization = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_DataSynchronization();
				dataSynchronization.Status = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataSynchronization.Status");
				dataSynchronization.Percent = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataSynchronization.Percent");
				dataSynchronization.ErrorMessage = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataSynchronization.ErrorMessage");
				dataSynchronization.Delay = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].DataSynchronization.Delay");
				migrationJob.DataSynchronization = dataSynchronization;

				List<DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SynchronousObject> migrationJob_migrationObject = new List<DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SynchronousObject>();
				for (int j = 0; j < context.Length("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationObject.Length"); j++) {
					DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SynchronousObject synchronousObject = new DescirbeMigrationJobsResponse.DescirbeMigrationJobs_MigrationJob.DescirbeMigrationJobs_SynchronousObject();
					synchronousObject.DatabaseName = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationObject["+ j +"].DatabaseName");
					synchronousObject.WholeDatabase = context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationObject["+ j +"].WholeDatabase");

					List<string> synchronousObject_tableList = new List<string>();
					for (int k = 0; k < context.Length("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationObject["+ j +"].TableList.Length"); k++) {
						synchronousObject_tableList.Add(context.StringValue("DescirbeMigrationJobs.MigrationJobs["+ i +"].MigrationObject["+ j +"].TableList["+ k +"]"));
					}
					synchronousObject.TableList = synchronousObject_tableList;

					migrationJob_migrationObject.Add(synchronousObject);
				}
				migrationJob.MigrationObject = migrationJob_migrationObject;

				descirbeMigrationJobsResponse_migrationJobs.Add(migrationJob);
			}
			descirbeMigrationJobsResponse.MigrationJobs = descirbeMigrationJobsResponse_migrationJobs;
        
			return descirbeMigrationJobsResponse;
        }
    }
}