/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeMigrationJobDetailResponseUnmarshaller
    {
        public static DescribeMigrationJobDetailResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeMigrationJobDetailResponse describeMigrationJobDetailResponse = new DescribeMigrationJobDetailResponse();

			describeMigrationJobDetailResponse.HttpResponse = context.HttpResponse;
			describeMigrationJobDetailResponse.PageNumber = context.IntegerValue("DescribeMigrationJobDetail.PageNumber");
			describeMigrationJobDetailResponse.TotalRecordCount = context.LongValue("DescribeMigrationJobDetail.TotalRecordCount");
			describeMigrationJobDetailResponse.PageRecordCount = context.IntegerValue("DescribeMigrationJobDetail.PageRecordCount");

			List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail> describeMigrationJobDetailResponse_structureInitializationDetailList = new List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail>();
			for (int i = 0; i < context.Length("DescribeMigrationJobDetail.StructureInitializationDetailList.Length"); i++) {
				DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail structureInitializationDetail = new DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail();
				structureInitializationDetail.ObjectName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ObjectName");
				structureInitializationDetail.ObjectType = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ObjectType");
				structureInitializationDetail.SourceOwnerDBName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].SourceOwnerDBName");
				structureInitializationDetail.DestinationOwnerDBName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].DestinationOwnerDBName");
				structureInitializationDetail.Status = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].Status");
				structureInitializationDetail.ErrorMessage = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ErrorMessage");
				structureInitializationDetail.ObjectDefinition = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ObjectDefinition");

				List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail.DescribeMigrationJobDetail_StructureInitializationDetail1> structureInitializationDetail_constraintList = new List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail.DescribeMigrationJobDetail_StructureInitializationDetail1>();
				for (int j = 0; j < context.Length("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList.Length"); j++) {
					DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail.DescribeMigrationJobDetail_StructureInitializationDetail1 structureInitializationDetail1 = new DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_StructureInitializationDetail.DescribeMigrationJobDetail_StructureInitializationDetail1();
					structureInitializationDetail1.ObjectName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].ObjectName");
					structureInitializationDetail1.ObjectType = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].ObjectType");
					structureInitializationDetail1.SourceOwnerDBName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].SourceOwnerDBName");
					structureInitializationDetail1.DestinationOwnerDBName = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].DestinationOwnerDBName");
					structureInitializationDetail1.Status = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].Status");
					structureInitializationDetail1.ErrorMessage = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].ErrorMessage");
					structureInitializationDetail1.ObjectDefinition = context.StringValue("DescribeMigrationJobDetail.StructureInitializationDetailList["+ i +"].ConstraintList["+ j +"].ObjectDefinition");

					structureInitializationDetail_constraintList.Add(structureInitializationDetail1);
				}
				structureInitializationDetail.ConstraintList = structureInitializationDetail_constraintList;

				describeMigrationJobDetailResponse_structureInitializationDetailList.Add(structureInitializationDetail);
			}
			describeMigrationJobDetailResponse.StructureInitializationDetailList = describeMigrationJobDetailResponse_structureInitializationDetailList;

			List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataInitializationDetail> describeMigrationJobDetailResponse_dataInitializationDetailList = new List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataInitializationDetail>();
			for (int i = 0; i < context.Length("DescribeMigrationJobDetail.DataInitializationDetailList.Length"); i++) {
				DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataInitializationDetail dataInitializationDetail = new DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataInitializationDetail();
				dataInitializationDetail.TableName = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].TableName");
				dataInitializationDetail.SourceOwnerDBName = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].SourceOwnerDBName");
				dataInitializationDetail.DestinationOwnerDBName = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].DestinationOwnerDBName");
				dataInitializationDetail.Status = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].Status");
				dataInitializationDetail.ErrorMessage = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].ErrorMessage");
				dataInitializationDetail.TotalRowNum = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].TotalRowNum");
				dataInitializationDetail.FinishRowNum = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].FinishRowNum");
				dataInitializationDetail.MigrationTime = context.StringValue("DescribeMigrationJobDetail.DataInitializationDetailList["+ i +"].MigrationTime");

				describeMigrationJobDetailResponse_dataInitializationDetailList.Add(dataInitializationDetail);
			}
			describeMigrationJobDetailResponse.DataInitializationDetailList = describeMigrationJobDetailResponse_dataInitializationDetailList;

			List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataSynchronizationDetail> describeMigrationJobDetailResponse_dataSynchronizationDetailList = new List<DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataSynchronizationDetail>();
			for (int i = 0; i < context.Length("DescribeMigrationJobDetail.DataSynchronizationDetailList.Length"); i++) {
				DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataSynchronizationDetail dataSynchronizationDetail = new DescribeMigrationJobDetailResponse.DescribeMigrationJobDetail_DataSynchronizationDetail();
				dataSynchronizationDetail.TableName = context.StringValue("DescribeMigrationJobDetail.DataSynchronizationDetailList["+ i +"].TableName");
				dataSynchronizationDetail.SourceOwnerDBName = context.StringValue("DescribeMigrationJobDetail.DataSynchronizationDetailList["+ i +"].SourceOwnerDBName");
				dataSynchronizationDetail.DestinationOwnerDBName = context.StringValue("DescribeMigrationJobDetail.DataSynchronizationDetailList["+ i +"].DestinationOwnerDBName");
				dataSynchronizationDetail.Status = context.StringValue("DescribeMigrationJobDetail.DataSynchronizationDetailList["+ i +"].Status");
				dataSynchronizationDetail.ErrorMessage = context.StringValue("DescribeMigrationJobDetail.DataSynchronizationDetailList["+ i +"].ErrorMessage");

				describeMigrationJobDetailResponse_dataSynchronizationDetailList.Add(dataSynchronizationDetail);
			}
			describeMigrationJobDetailResponse.DataSynchronizationDetailList = describeMigrationJobDetailResponse_dataSynchronizationDetailList;
        
			return describeMigrationJobDetailResponse;
        }
    }
}