/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeMigrationJobStatusResponseUnmarshaller
    {
        public static DescribeMigrationJobStatusResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeMigrationJobStatusResponse describeMigrationJobStatusResponse = new DescribeMigrationJobStatusResponse();

			describeMigrationJobStatusResponse.HttpResponse = context.HttpResponse;
			describeMigrationJobStatusResponse.MigrationJobId = context.StringValue("DescribeMigrationJobStatus.MigrationJobId");
			describeMigrationJobStatusResponse.MigrationJobName = context.StringValue("DescribeMigrationJobStatus.MigrationJobName");
			describeMigrationJobStatusResponse.PayType = context.StringValue("DescribeMigrationJobStatus.PayType");
			describeMigrationJobStatusResponse.MigrationJobClass = context.StringValue("DescribeMigrationJobStatus.MigrationJobClass");
			describeMigrationJobStatusResponse.MigrationObject = context.StringValue("DescribeMigrationJobStatus.MigrationObject");
			describeMigrationJobStatusResponse.MigrationJobStatus = context.StringValue("DescribeMigrationJobStatus.MigrationJobStatus");

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_SourceEndpoint sourceEndpoint = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_SourceEndpoint();
			sourceEndpoint.InstanceType = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.InstanceType");
			sourceEndpoint.InstanceId = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.InstanceId");
			sourceEndpoint.EngineName = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.EngineName");
			sourceEndpoint.IP = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.IP");
			sourceEndpoint.Port = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.Port");
			sourceEndpoint.DatabaseName = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.DatabaseName");
			sourceEndpoint.OracleSID = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.OracleSID");
			sourceEndpoint.UserName = context.StringValue("DescribeMigrationJobStatus.SourceEndpoint.UserName");
			describeMigrationJobStatusResponse.SourceEndpoint = sourceEndpoint;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DestinationEndpoint destinationEndpoint = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DestinationEndpoint();
			destinationEndpoint.InstanceType = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.InstanceType");
			destinationEndpoint.InstanceId = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.InstanceId");
			destinationEndpoint.EngineName = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.EngineName");
			destinationEndpoint.IP = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.IP");
			destinationEndpoint.Port = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.Port");
			destinationEndpoint.DatabaseName = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.DatabaseName");
			destinationEndpoint.OracleSID = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.OracleSID");
			destinationEndpoint.UserName = context.StringValue("DescribeMigrationJobStatus.DestinationEndpoint.UserName");
			describeMigrationJobStatusResponse.DestinationEndpoint = destinationEndpoint;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_MigrationMode migrationMode = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_MigrationMode();
			migrationMode.StructureInitialization = context.BooleanValue("DescribeMigrationJobStatus.MigrationMode.StructureInitialization");
			migrationMode.DataInitialization = context.BooleanValue("DescribeMigrationJobStatus.MigrationMode.DataInitialization");
			migrationMode.DataSynchronization = context.BooleanValue("DescribeMigrationJobStatus.MigrationMode.DataSynchronization");
			describeMigrationJobStatusResponse.MigrationMode = migrationMode;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus precheckStatus = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus();
			precheckStatus.Status = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Status");
			precheckStatus.Percent = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Percent");

			List<DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus.DescribeMigrationJobStatus_CheckItem> precheckStatus_detail = new List<DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus.DescribeMigrationJobStatus_CheckItem>();
			for (int i = 0; i < context.Length("DescribeMigrationJobStatus.PrecheckStatus.Detail.Length"); i++) {
				DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus.DescribeMigrationJobStatus_CheckItem checkItem = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_PrecheckStatus.DescribeMigrationJobStatus_CheckItem();
				checkItem.ItemName = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Detail["+ i +"].ItemName");
				checkItem.CheckStatus = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Detail["+ i +"].CheckStatus");
				checkItem.ErrorMessage = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Detail["+ i +"].ErrorMessage");
				checkItem.RepairMethod = context.StringValue("DescribeMigrationJobStatus.PrecheckStatus.Detail["+ i +"].RepairMethod");

				precheckStatus_detail.Add(checkItem);
			}
			precheckStatus.Detail = precheckStatus_detail;
			describeMigrationJobStatusResponse.PrecheckStatus = precheckStatus;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_StructureInitializationStatus structureInitializationStatus = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_StructureInitializationStatus();
			structureInitializationStatus.Status = context.StringValue("DescribeMigrationJobStatus.StructureInitializationStatus.Status");
			structureInitializationStatus.Percent = context.StringValue("DescribeMigrationJobStatus.StructureInitializationStatus.Percent");
			structureInitializationStatus.ErrorMessage = context.StringValue("DescribeMigrationJobStatus.StructureInitializationStatus.ErrorMessage");
			structureInitializationStatus.Progress = context.StringValue("DescribeMigrationJobStatus.StructureInitializationStatus.Progress");
			describeMigrationJobStatusResponse.StructureInitializationStatus = structureInitializationStatus;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DataInitializationStatus dataInitializationStatus = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DataInitializationStatus();
			dataInitializationStatus.Status = context.StringValue("DescribeMigrationJobStatus.DataInitializationStatus.Status");
			dataInitializationStatus.Percent = context.StringValue("DescribeMigrationJobStatus.DataInitializationStatus.Percent");
			dataInitializationStatus.ErrorMessage = context.StringValue("DescribeMigrationJobStatus.DataInitializationStatus.ErrorMessage");
			dataInitializationStatus.Progress = context.StringValue("DescribeMigrationJobStatus.DataInitializationStatus.Progress");
			describeMigrationJobStatusResponse.DataInitializationStatus = dataInitializationStatus;

			DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DataSynchronizationStatus dataSynchronizationStatus = new DescribeMigrationJobStatusResponse.DescribeMigrationJobStatus_DataSynchronizationStatus();
			dataSynchronizationStatus.Status = context.StringValue("DescribeMigrationJobStatus.DataSynchronizationStatus.Status");
			dataSynchronizationStatus.Percent = context.StringValue("DescribeMigrationJobStatus.DataSynchronizationStatus.Percent");
			dataSynchronizationStatus.ErrorMessage = context.StringValue("DescribeMigrationJobStatus.DataSynchronizationStatus.ErrorMessage");
			dataSynchronizationStatus.Delay = context.StringValue("DescribeMigrationJobStatus.DataSynchronizationStatus.Delay");
			describeMigrationJobStatusResponse.DataSynchronizationStatus = dataSynchronizationStatus;
        
			return describeMigrationJobStatusResponse;
        }
    }
}