/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeSubscriptionInstancesResponseUnmarshaller
    {
        public static DescribeSubscriptionInstancesResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeSubscriptionInstancesResponse describeSubscriptionInstancesResponse = new DescribeSubscriptionInstancesResponse();

			describeSubscriptionInstancesResponse.HttpResponse = context.HttpResponse;
			describeSubscriptionInstancesResponse.PageNumber = context.IntegerValue("DescribeSubscriptionInstances.PageNumber");
			describeSubscriptionInstancesResponse.TotalRecordCount = context.LongValue("DescribeSubscriptionInstances.TotalRecordCount");
			describeSubscriptionInstancesResponse.PageRecordCount = context.IntegerValue("DescribeSubscriptionInstances.PageRecordCount");

			List<DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance> describeSubscriptionInstancesResponse_subscriptionInstances = new List<DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance>();
			for (int i = 0; i < context.Length("DescribeSubscriptionInstances.SubscriptionInstances.Length"); i++) {
				DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance subscriptionInstance = new DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance();
				subscriptionInstance.SubscriptionInstanceID = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionInstanceID");
				subscriptionInstance.SubscriptionInstanceName = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionInstanceName");
				subscriptionInstance.PayType = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].PayType");
				subscriptionInstance.Status = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].Status");
				subscriptionInstance.ErrorMessage = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].ErrorMessage");
				subscriptionInstance.ConsumptionCheckpoint = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].ConsumptionCheckpoint");
				subscriptionInstance.BeginTimestamp = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].BeginTimestamp");
				subscriptionInstance.EndTimestamp = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].EndTimestamp");
				subscriptionInstance.ConsumptionClient = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].ConsumptionClient");

				DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SourceEndpoint sourceEndpoint = new DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SourceEndpoint();
				sourceEndpoint.InstanceID = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SourceEndpoint.InstanceID");
				sourceEndpoint.InstanceType = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SourceEndpoint.InstanceType");
				subscriptionInstance.SourceEndpoint = sourceEndpoint;

				DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SubscriptionDataType subscriptionDataType = new DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SubscriptionDataType();
				subscriptionDataType.DDL = context.BooleanValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionDataType.DDL");
				subscriptionDataType.DML = context.BooleanValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionDataType.DML");
				subscriptionInstance.SubscriptionDataType = subscriptionDataType;

				List<DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SynchronousObject> subscriptionInstance_subscriptionObject = new List<DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SynchronousObject>();
				for (int j = 0; j < context.Length("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionObject.Length"); j++) {
					DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SynchronousObject synchronousObject = new DescribeSubscriptionInstancesResponse.DescribeSubscriptionInstances_SubscriptionInstance.DescribeSubscriptionInstances_SynchronousObject();
					synchronousObject.DatabaseName = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionObject["+ j +"].DatabaseName");
					synchronousObject.WholeDatabase = context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionObject["+ j +"].WholeDatabase");

					List<string> synchronousObject_tableList = new List<string>();
					for (int k = 0; k < context.Length("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionObject["+ j +"].TableList.Length"); k++) {
						synchronousObject_tableList.Add(context.StringValue("DescribeSubscriptionInstances.SubscriptionInstances["+ i +"].SubscriptionObject["+ j +"].TableList["+ k +"]"));
					}
					synchronousObject.TableList = synchronousObject_tableList;

					subscriptionInstance_subscriptionObject.Add(synchronousObject);
				}
				subscriptionInstance.SubscriptionObject = subscriptionInstance_subscriptionObject;

				describeSubscriptionInstancesResponse_subscriptionInstances.Add(subscriptionInstance);
			}
			describeSubscriptionInstancesResponse.SubscriptionInstances = describeSubscriptionInstancesResponse_subscriptionInstances;
        
			return describeSubscriptionInstancesResponse;
        }
    }
}