/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeSynchronizationObjectModifyStatusResponseUnmarshaller
    {
        public static DescribeSynchronizationObjectModifyStatusResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeSynchronizationObjectModifyStatusResponse describeSynchronizationObjectModifyStatusResponse = new DescribeSynchronizationObjectModifyStatusResponse();

			describeSynchronizationObjectModifyStatusResponse.HttpResponse = context.HttpResponse;
			describeSynchronizationObjectModifyStatusResponse.RequestId = context.StringValue("DescribeSynchronizationObjectModifyStatus.RequestId");
			describeSynchronizationObjectModifyStatusResponse.Status = context.StringValue("DescribeSynchronizationObjectModifyStatus.Status");
			describeSynchronizationObjectModifyStatusResponse.ErrorMessage = context.StringValue("DescribeSynchronizationObjectModifyStatus.ErrorMessage");

			DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus precheckStatus = new DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus();
			precheckStatus.Status = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Status");
			precheckStatus.Percent = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Percent");

			List<DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus.DescribeSynchronizationObjectModifyStatus_CheckItem> precheckStatus_detail = new List<DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus.DescribeSynchronizationObjectModifyStatus_CheckItem>();
			for (int i = 0; i < context.Length("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Detail.Length"); i++) {
				DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus.DescribeSynchronizationObjectModifyStatus_CheckItem checkItem = new DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_PrecheckStatus.DescribeSynchronizationObjectModifyStatus_CheckItem();
				checkItem.ItemName = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Detail["+ i +"].ItemName");
				checkItem.CheckStatus = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Detail["+ i +"].CheckStatus");
				checkItem.ErrorMessage = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Detail["+ i +"].ErrorMessage");
				checkItem.RepairMethod = context.StringValue("DescribeSynchronizationObjectModifyStatus.PrecheckStatus.Detail["+ i +"].RepairMethod");

				precheckStatus_detail.Add(checkItem);
			}
			precheckStatus.Detail = precheckStatus_detail;
			describeSynchronizationObjectModifyStatusResponse.PrecheckStatus = precheckStatus;

			DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_StructureInitializationStatus structureInitializationStatus = new DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_StructureInitializationStatus();
			structureInitializationStatus.Status = context.StringValue("DescribeSynchronizationObjectModifyStatus.StructureInitializationStatus.Status");
			structureInitializationStatus.Percent = context.StringValue("DescribeSynchronizationObjectModifyStatus.StructureInitializationStatus.Percent");
			structureInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationObjectModifyStatus.StructureInitializationStatus.ErrorMessage");
			structureInitializationStatus.Progress = context.StringValue("DescribeSynchronizationObjectModifyStatus.StructureInitializationStatus.Progress");
			describeSynchronizationObjectModifyStatusResponse.StructureInitializationStatus = structureInitializationStatus;

			DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_DataInitializationStatus dataInitializationStatus = new DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_DataInitializationStatus();
			dataInitializationStatus.Status = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataInitializationStatus.Status");
			dataInitializationStatus.Percent = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataInitializationStatus.Percent");
			dataInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataInitializationStatus.ErrorMessage");
			dataInitializationStatus.Progress = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataInitializationStatus.Progress");
			describeSynchronizationObjectModifyStatusResponse.DataInitializationStatus = dataInitializationStatus;

			DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_DataSynchronizationStatus dataSynchronizationStatus = new DescribeSynchronizationObjectModifyStatusResponse.DescribeSynchronizationObjectModifyStatus_DataSynchronizationStatus();
			dataSynchronizationStatus.Status = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataSynchronizationStatus.Status");
			dataSynchronizationStatus.Percent = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataSynchronizationStatus.Percent");
			dataSynchronizationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataSynchronizationStatus.ErrorMessage");
			dataSynchronizationStatus.Delay = context.StringValue("DescribeSynchronizationObjectModifyStatus.DataSynchronizationStatus.Delay");
			describeSynchronizationObjectModifyStatusResponse.DataSynchronizationStatus = dataSynchronizationStatus;
        
			return describeSynchronizationObjectModifyStatusResponse;
        }
    }
}